<script lang="ts" setup>
import { License } from '../utils/schema/license';

const props = defineProps<{
  licenses: License[];
}>();

const {
  selectedObligations,
  selectedPermissions,
  selectedProhibitions,
  selectedLicenseFilters,
  handleRemove,
  handleClearFilters,
  computedLicenseRows
} = useLicenseFilters(props.licenses);

</script>

<template>
  <div>
    <h1 class="ecl-page-header-standardised ecl-page-header-standardised__title">Licensing Assistant</h1>
    <div class="page-description ecl-blockquote mb-4"><div class="ecl-blockquote__body">Data which is shared with a licence becomes Open Data. There are many licences available. The licence assistant provides a description of the available licences. It also gives an overview of how to apply licences as a re-publisher/distributor of Open Data nad how to combine multiple licences.</div></div>
    <div class="ecl-container p-0">
      <div class="row">
        <div class="col-12 col-md-4 col-lg-3">
          <InputsLicenseFilters
            v-model:selected-obligations="selectedObligations"
            v-model:selected-permissions="selectedPermissions"
            v-model:selected-prohibitions="selectedProhibitions"
          />
          <EcButton type="secondary" @click="handleClearFilters">Clear filters</EcButton>
        </div>
        <div class="col-12 col-md-8 col-lg-9">
          <!-- <div class="dummy-results">licenses</div> -->
          <section>
            <h5>Results <span>({{ computedLicenseRows.length }})</span> </h5>
            <hr>
            <div class="my-2">
              <div class="my-2" v-for="(filters, key) in selectedLicenseFilters" :key="key">
                <template v-if="filters.length">
                  {{ key }}:
                  <div class="d-inline-flex flex-row">
                    <EcTag @click="handleRemove({
                      key,
                      value: filter,
                    })" type="removable" v-for="filter in filters" :key="filter" class="mx-1">
                      {{ filter }}
                    </EcTag>
                  </div>
                </template>
              </div>
            </div>
          </section>
          <EcTable
            :headers="{
              name: 'Name',
              terms: 'Terms',
            }"
            :rows="computedLicenseRows"
            v-slot="{ row, col, value }"
          >
          <template v-if="col==='name'">
            <EcLink type="standalone" :to="{ name: 'license-details', query: { id: licenses[row].shortName } }">
              {{ value }}
            </EcLink>
          </template>
        </EcTable>
        </div>
      </div>

    </div>
    <div class="button-container">
        <EcButton type="primary">Primary</EcButton>
        <EcButton type="primary">
          Icon
          <template #icon>
            <icon-ec-audio />
          </template>
        </EcButton>
        <EcButton type="secondary">Secondary</EcButton>
        <EcButton type="call">Call</EcButton>
        <EcButton type="ghost">Ghost</EcButton>
      </div>
    <div class="button-container">
        <EcTag type="display">Primary</EcTag>
        <EcTag type="removable">Removable</EcTag>
        <EcTag type="link" link="#">Link</EcTag>
      </div>
      <div class="button-container">
        <EcLink href="/component-library/example" type="default">
          Default link
        </EcLink>
        <EcLink href="/component-library/example" type="standalone">
          Standalone link
        </EcLink>
        <EcLink
          href="/component-library/example"
          type="default"
          icon="external"
        >
          Link with icon
        </EcLink>
        <EcLink href="/component-library/example" type="cta">
          Call to action link
        </EcLink>
        <EcLink href="/component-library/example" type="cta">
          Link Icon
          <template #icon>
            <icon-ec-audio />
          </template>
        </EcLink>
        <EcLink href="/component-library/example" type="primary">
          Primary link
        </EcLink>
        <EcLink href="/component-library/example" type="secondary">
          Secondary link
        </EcLink>
        <EcLink href="/component-library/example" type="negative">
          Negative link
        </EcLink>
      </div>
      <div class="mockbox">
        {{ JSON.stringify(selectedLicenseFilters, null, 2) }}
      </div>
      <div class="mockbox">
        {{ JSON.stringify(licenses, null, 2) }}
      </div>
  </div>
</template>

<script setup lang="ts">

</script>

<style scoped lang="scss">
.button-container {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
  margin: 2rem;

  button, a {
    margin: .5rem;
  }
}

.page-description {
  max-width: 40rem;
}

.dummy-results {
  height: 1200px;
  display: grid;
  place-items: center;
  background-color: #f2f2f2;
}

.mockbox {
  width: 100%;
  height: 500px;
  border: 1px solid #ccc;
  border-radius: 4px;
  padding: 10px;
  font-family: monospace;
  font-size: 12px;
  line-height: 1.5;
  color: #333;
  background-color: #f5f5f5;
  resize: none;
  overflow: auto;
}
</style>
